︠1345e1e0-242a-4305-bf17-3f49212f3240i︠
%html
<h2 style="color:blue">
    Bard - Sage - Secant Line Approximation Demo
</h2>
︡efdce119-d142-4a86-a16d-d38f8622aaf9︡{"html":"<h2 style=\"color:blue\">\n    Bard - Sage - Secant Line Approximation Demo\n</h2>\n"}︡
︠8c0e3f17-7c49-4a83-b5b7-4b4ea1e44f6d︠
%html

<ul>
    <li>Put the cursor in the code, and then click on Run (the green square with the in the middle of the above menu above).</li>
    <li>You can change the function $f(x)$, the point $a$, and the $x$-interval and $y$-interval.</li>
    <li>Click on different values of $h$, using either $+h$ or $-h$, and see what happens to graph of the secant line and to the difference quotient.</li>
</ul>

︡c843a07d-5aee-4410-a51a-4dacb511f018︡{"html":"\n<ul>\n    <li>Put the cursor in the code, and then click on Run.</li>\n    <li>You can change the function $f(x)$, the point $a$, and the $x$-interval and $y$-interval.</li>\n    <li>Click on different values of $h$, using either $+h$ or $-h$, and see what happens to graph of the secant line and to the difference quotient.</li>\n</ul>\n\n"}︡
︠8cd33e62-27f9-43aa-8c4f-2235fac330c4︠
@interact
def _(
f = input_box(default=x^2),
a = input_box(default=3),
xinterval=range_slider(-10, 10, 1, default=(-4, 6), label="x-interval"),
yinterval=range_slider(-100, 100, 1, default=(-5, 36), label="y-interval"),
h = selector([2, 1, 1/2, 1/10, 1/100, 1/1000, 1/10000, 1/100000, 1/1000000], nrows=1),
pm = selector(['+h', '-h'], nrows=1, label="plus/minus")
):
    x_min, x_max = map(QQ, xinterval)
    y_min, y_max = map(QQ, yinterval)
    if pm == '-h':
        hw = -h
    elif pm == '+h':
        hw = h
    hh = n(hw);
    aa = n(a);
    fa = n(f(a));
    fah = n(f(a + hw));
    ah = n(a + hw);
    sl = n((f(a + hw)-f(a))/hw);
    lf = sl*(x - aa) + fa;
    derf = derivative(f,x);
    derfa = n(derf(a));
    tanf = derfa*(x - aa) + fa
    plf = plot(f, x_min, x_max, ymin = y_min, ymax = y_max)
    pllf = plot(lf, x_min, x_max, ymin = y_min, ymax = y_max, rgbcolor = (1,0,0))
    pldf = plot(tanf, x_min, x_max, ymin = y_min, ymax = y_max, color = "darkgreen")
    apt = point((aa,fa), color = "darkgreen", size=40)
    bpt = point((ah,fah), rgbcolor = (1,0,0), size=40)
    html(r'''
    <div class="math">
    \begin{align*}
    f(x) &= %s \\\
    a &= %s \\\
    h &= %s \\\
    b &= %s \\\
    {f(a + h) - f(a) \over h} = {f(b) - f(a) \over b - a} &= %s .
    \end{align*}
    </div>
    ''' % (latex(f), aa, hh, ah, sl))
    show(plf + pllf + pldf + apt + bpt, figsize=10)
︡edf8842f-b23e-41fa-9cfc-d60dd8836a2b︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["a",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["h",12,null]],[["pm",12,null]],[["",12,null]]],"id":"f16ed059-efdd-4747-8036-c67ff6cd781d","controls":[{"control_type":"input-box","default":"x^2","label":"f","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"input-box","default":3,"label":"a","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"a","type":null},{"control_type":"range-slider","default":[6,16],"var":"xinterval","width":null,"vals":["-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10"],"animate":true,"label":"x-interval","display_value":true},{"control_type":"range-slider","default":[95,136],"var":"yinterval","width":null,"vals":["-100","-99","-98","-97","-96","-95","-94","-93","-92","-91","-90","-89","-88","-87","-86","-85","-84","-83","-82","-81","-80","-79","-78","-77","-76","-75","-74","-73","-72","-71","-70","-69","-68","-67","-66","-65","-64","-63","-62","-61","-60","-59","-58","-57","-56","-55","-54","-53","-52","-51","-50","-49","-48","-47","-46","-45","-44","-43","-42","-41","-40","-39","-38","-37","-36","-35","-34","-33","-32","-31","-30","-29","-28","-27","-26","-25","-24","-23","-22","-21","-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"],"animate":true,"label":"y-interval","display_value":true},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["2","1","1/2","1/10","1/100","1/1000","1/10000","1/100000","1/1000000"],"label":"h","nrows":1,"width":null,"var":"h"},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["+h","-h"],"label":"plus/minus","nrows":1,"width":null,"var":"pm"}]}}︡
︠b3b71cf1-db6f-4a7a-9a80-6ecb78b36a25︠









